using System;
using MVR.FileManagementSecure;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using SimpleJSON;
using UnityEngine.UI;


namespace NeMech 
{
    public class NeMech_S017: MVRScript
    {

	const string manName = "Bebad";    	
	const string SceanName = "S017";
	const float unLockOrgasmTime = 6.0f;
    
	
	const string virsionMmsg = "<b>=== NeMech_"+ SceanName + " V1.0 ===</b>\nPC-Paid Content.\n<color=purple>Redistribution prohibited.</color>\nAlteration prohibited\nNeMech_a.cs Ver1.0 \n\nCreated by NeMech in 2022/10\nLastUpdate by Nemech in 2022/10 \nhttps://www.patreon.com/nemech";

	private JSONStorableString jstring;

	private JSONStorableBool UpDownState;	// true: lieDown  false: stand
	private JSONStorableBool LegState;	    // true: open     false: close
	private bool SexAnimation;	// true: execute
	private int LevelAdd;
	private bool buttonLockOrgasm;
	private float VAMMValue_TriggerCount;


		public SaveData Sd;
		private SaveData Sdcurrent;
		private TimeSpan todaysOrgasmIntervalMark;
		private DateTime lastOrgasmTime;
		private DateTime newOrgasmTime;
    	
		const string SavePath = "Saves/PluginData/NemechGameSaves/";
		const string SaveFile = SceanName + ".save";

		private int gameEvent;

		protected UIDynamicButton dbutton;
		protected JSONStorableAction manualSwTrigger;
		protected JSONStorableFloat LevelSlider;
		CollisionTrigger executeTrigger;
		private UIDynamicSlider dslider;


        public override void Init()
        {
			SexAnimation = false;
			LevelAdd = 1;
			buttonLockOrgasm = false;
        	todaysOrgasmIntervalMark = new TimeSpan(23, 59, 58);
        	Sd = new SaveData();

        	
			CollisionTrigger executeTrigger = containingAtom.GetStorableByID("CollisionTrigger") as CollisionTrigger;
			JSONClass trigClass = executeTrigger.trigger.GetJSON();
			JSONArray trigArray = trigClass["startActions"].AsArray;
//			trigArray[0]["enabled"].Value = "true";		// 0: insertStatus Move
			trigArray[1]["enabled"].Value = "true";		// 1: GabrielTalk not use in S016
			trigArray[2]["enabled"].Value = "true";		// 2: PersonTL text
			trigArray[3]["enabled"].Value = "true";		// 3: Orgasm : Call From MAMMoan
			trigArray[4]["enabled"].Value = "true";		// 4: appendex in S016 not use
			executeTrigger.trigger.RestoreFromJSON(trigClass);

        	lastOrgasmTime = DateTime.Now;
        	newOrgasmTime = DateTime.Now.AddDays(0.5);
        	
            try
            {
				// Plugin InfoMation
				jstring = new JSONStorableString("ContensMessage", virsionMmsg );
				dtext = CreateTextField(jstring);
				dtext.height=360f;

				manualSwTrigger = new JSONStorableAction("startSex",startSexCallback);
				RegisterAction(manualSwTrigger);

				manualSwTrigger = new JSONStorableAction("AnimeFlagOff",()=>
				{
					SexAnimation = false;
				});
				RegisterAction(manualSwTrigger);
 
				manualSwTrigger = new JSONStorableAction("insertStatus",insertStatusCallback);
				RegisterAction(manualSwTrigger);

				manualSwTrigger = new JSONStorableAction("Orgasm",()=>
				{
					if(buttonLockOrgasm == true) return;
					buttonLockOrgasm = true;
					Invoke( "unLockOrgasm",unLockOrgasmTime );

					newOrgasmTime = DateTime.Now;
					
					executeTrigger = containingAtom.GetStorableByID("CollisionTrigger") as CollisionTrigger;
					executeTrigger.trigger.active = true;
					executeTrigger.trigger.active = false;		

					Sd.thisOrgasmCount ++;
					if( (Sd.thisOrgasmCount ) % 4 == 0) swet();

					
					Sd.EffeciveOrgasmCount += LevelAdd ;
					if(Sd.EffeciveOrgasmCount >= 20){
						Sd.EffeciveOrgasmCount = 0;
						LevelAdd = 0;
						Sd.levelInfo ++;
						if(Sd.levelInfo > 7) Sd.levelInfo = 8;
					}
					
					textInfoDisplay();
					Invoke( "SexAnimeOff",20f);
					dildwet();
				});
				RegisterAction(manualSwTrigger);


				// JSONStorableFloat
//				LevelSlider = new JSONStorableFloat("LevelSlider", 7.0f, LevelSliderCallback, 1.0f, 8.0f, true);
//				RegisterFloat(LevelSlider);


				// JSONStorableToggle *** UpDownState **** 
				UpDownState = new JSONStorableBool("UpDownState(open: lieDown)", false);
				RegisterBool(UpDownState);
				UpDownState.val = false;

				// JSONStorableToggle *** LegState **** 
				LegState = new JSONStorableBool("LegState(true: open)", false);
				RegisterBool(LegState);
				LegState.val = true;

				// JSONStorableString
				pluginInfo = new JSONStorableString("pluginInfo", "" );
				dtext = CreateTextField(pluginInfo,true);
				dtext.height=360f;
//				dtext.height=30f;

//				LevelSliderCallback(LevelSlider);


			}
			catch (Exception e)
			{
    	    	SuperController.LogError("Exception caught: " + e);
	        }

		}
		private void unLockOrgasm(){
			buttonLockOrgasm = false;
		}

		private void SexAnimeOff()
		{
			SexAnimation = false;
		}

		private UIDynamicTextField dtext;
		private JSONStorableString pluginInfo;

		TimeSpan timed ;


		void  Start() {
			string thisBoot;
			thisBoot = DateTime.Now.ToString();

			gameLoad();

			
			
			statisProcess();
			
			if( Sd.startCount == 0){
				// 1st play
				gameEvent = 1;
				Sd.FirstBoot = thisBoot;
				Sd.favRate ++;
			}

			Sd.lastBoot = DateTime.Now.ToString();
			gameSave();
			InvokeRepeating("gameSave",120f,120f);

		}
		
		void statisProcess(){

			Sd.id = SaveFile;
			Sd.startCount ++;
			Sd.totalPlaytime += Sd.thisPlaytime;
			Sd.thisPlaytime = 0;
			
			Sd.totalOrgasmCount += Sd.thisOrgasmCount;
			Sd.maximumOrgasmCount = ( Sd.maximumOrgasmCount > Sd.thisOrgasmCount) ?  Sd.maximumOrgasmCount : Sd.thisOrgasmCount ;
			Sd.thisOrgasmCount = 0;
			
			if(Sd.levelInfo == 0) Sd.levelInfo ++;

			textInfoDisplay();

			
		}

		void textInfoDisplay(){

			if(SuperController.singleton.GetAtomByUid("GameInfoText") != null){
				string infoMessage;
				Atom textobject;
				textobject = SuperController.singleton.GetAtomByUid("GameInfoText");

				Text m_Text;
				m_Text = textobject.GetComponentInChildren<Text>();
				m_Text.alignment = TextAnchor.UpperLeft;
				m_Text.supportRichText = true;

				
				// Orgasm Interval
				TimeSpan ts = newOrgasmTime - lastOrgasmTime;
				if(ts < todaysOrgasmIntervalMark) todaysOrgasmIntervalMark = ts;

				if(Sd.thisOrgasmCount>0){
					if(ts < TimeSpan.Parse (Sd.ShortestOrgasmTimeInterval)) {
						Sd.ShortestOrgasmTimeInterval = ts.ToString();
					}
				}
				
				
				
				infoMessage =  "<size=60><b><color=#0DA>Nemech "+ SceanName + " ver1.00</color></b></size>" +
								"\n<size=30><color=#0DA>release date: 2022/10/22 </color></size>" +
								"\n<size=30><color=#0DA>lastUpdate:  2022/10/22 </color></size>\n" +
								"\n<b><color=olive>Start count</color></b>: <color=brown> " +  Sd.startCount + " times</color>" +
//								"\n<b><color=olive>lastBoot</color></b>: <color=brown> " +  Sd.lastBoot + " </color>" +
								"\n<b><color=olive>totalPlaytime</color></b>: <color=brown>" +  (Sd.totalPlaytime+Sd.thisPlaytime)*2 + " min</color>" +
								"\n<b><color=olive>totalOrgasmCount</color></b>: <color=brown>" +  (Sd.totalOrgasmCount+ Sd.thisOrgasmCount) + " times</color>" +
								"\n<b><color=olive>maximumOrgasmCount</color></b>: <color=brown>" +  Sd.maximumOrgasmCount + " times</color>" +
								"\n<b><color=olive>thisOrgasmCount</color></b>: <color=orange>" + Sd.thisOrgasmCount + " times</color>" ;

				if(Sd.ShortestOrgasmTimeInterval == todaysOrgasmIntervalMark.ToString() )
					infoMessage =  infoMessage +  "\n<b><color=olive>Shortest Orgasm Interval Record</color></b>: <color=magenta>" +  Sd.ShortestOrgasmTimeInterval + " </color>";   //
				else 
					infoMessage =  infoMessage +  "\n<b><color=olive>Shortest Orgasm Interval Record</color></b>: <color=brown>" +  Sd.ShortestOrgasmTimeInterval + " </color>";   //
				
				infoMessage =  infoMessage +  "\n<b><color=olive>ThisOrgasm Interval Record</color></b>: <color=orange>" +  todaysOrgasmIntervalMark.ToString() + " </color>";   //
				infoMessage =  infoMessage +  "\n<b><color=olive>ThisOrgasm Interval</color></b>: <color=brown>" +  ts.ToString() + " </color>";   //
				


				
				string levText;

				int tgtCt = (int)(Sd.totalOrgasmCount+ Sd.thisOrgasmCount)/10;
				levText = "";

				switch(tgtCt){
				case 0:	levText = "Beginner"; break;
				case 1:	levText = "Amoeba"; break;
				case 2:	levText = "Elephant worm"; break;
				case 3:	levText = "Water flea"; break;
				case 4:	levText = "Tardigrades"; break;
				case 5:	levText = "Jellyfish"; break;
				case 6:	levText = "Octopus"; break;
				case 7:	levText = "Crab"; break;
				case 8:	levText = "Sea cucumber"; break;
				case 9:	levText = "Eel"; break;
				case 10:	levText = "Shark"; break;
				case 11:	levText = "Tuna"; break;
				case 12:	levText = "Tarsier"; break;
				case 13:	levText = "Tengu monkeys"; break;
				case 14:	levText = "Lar gibbon"; break;
				case 15:	levText = "Orangutan"; break;
				case 16:	levText = "Gorilla"; break;
				case 17:	levText = "Chimpanzee"; break;
				case 18:	levText = "Neanderthal man"; break;
				case 19:	levText = "Homo sapiens"; break;
				case 20:	levText = "Spirit"; break;
				case 21:	levText = "God"; break;
				default :levText = "You are God Player! Oh no, I'm out of ideas."; break;
					
				}

				if((int)tgtCt%2 == 0)
					infoMessage = infoMessage + "\n<b><color=teal>playerLevelInfo</color></b>: <color=cyan> "+ levText +" </color>" ;
				else
					infoMessage = infoMessage + "\n<b><color=teal>playerLevelInfo</color></b>: <color=lime> "+ levText +" </color>" ;
										
				textobject.GetStorableByID("Text").SetStringParamValue("text",infoMessage);

			}


			
			gameSave();
		}

		void swet(){

			CollisionTrigger executeTrigger = containingAtom.GetStorableByID("CollisionTrigger") as CollisionTrigger;
			JSONClass trigClass = executeTrigger.trigger.GetJSON();
			JSONArray trigArray = trigClass["startActions"].AsArray;
			string womanAtomName = trigArray[3]["receiverAtom"].Value;
			JSONStorable skinObject = SuperController.singleton.GetAtomByUid(womanAtomName).GetStorableByID("skin");

			float targetValue;

			targetValue = skinObject.GetFloatParamValue("Specular Texture Offset");
			targetValue = targetValue + (1 - targetValue )/8;
			skinObject.SetFloatParamValue("Specular Texture Offset",targetValue);
			
			targetValue = skinObject.GetFloatParamValue("Specular Intensity");
			targetValue = targetValue + (10 - targetValue )/8;
			skinObject.SetFloatParamValue("Specular Intensity",targetValue);
		
			targetValue = skinObject.GetFloatParamValue("Gloss");
			targetValue = targetValue + (8 - targetValue )/8;
			skinObject.SetFloatParamValue("Gloss",targetValue);

			targetValue = skinObject.GetFloatParamValue("Specular Fresnel");
			targetValue = targetValue - targetValue/8;
			skinObject.SetFloatParamValue("Specular Fresnel",targetValue);

			targetValue = skinObject.GetFloatParamValue("Diffuse Texture Offset");
			targetValue = targetValue - 0.01f;
			skinObject.SetFloatParamValue("Diffuse Texture Offset",targetValue);


		}


		private void dildwet(){

			float targetValue;
			
			// dildo
			Atom dildoAtom = SuperController.singleton.GetAtomByUid("Dildo");
			if(dildoAtom != null){
				JSONStorable dildoObject = dildoAtom.GetStorableByID("materials");
				targetValue = dildoObject.GetFloatParamValue("Specular Texture Offset");
				targetValue = targetValue + (1 - targetValue )/4;
				dildoObject.SetFloatParamValue("Specular Texture Offset",targetValue);

				targetValue = dildoObject.GetFloatParamValue("Specular Intensity");
				targetValue = targetValue + (10 - targetValue )/8;
				dildoObject.SetFloatParamValue("Specular Intensity",targetValue);
			
				targetValue = dildoObject.GetFloatParamValue("Gloss");
				targetValue = targetValue + (8 - targetValue )/8;
				dildoObject.SetFloatParamValue("Gloss",targetValue);


				HSVColor dildoColor;
				dildoColor = dildoObject.GetColorParamValue("Diffuse Color");
				dildoColor.H = dildoColor.H - (dildoColor.H - 0.644651f)/4f;
				dildoColor.S = dildoColor.S - (dildoColor.S - 0.9395687f)/4f;
				dildoColor.V = dildoColor.V - (dildoColor.V - 0.3752951f)/4f;
				dildoObject.SetColorParamValue("Diffuse Color",dildoColor);
			}
		
		}

		void LevelSliderCallback(JSONStorableFloat jf){
			int lev;
			lev = (int)jf.val;
			Atom labelTarget = SuperController.singleton.GetAtomByUid("LevelChanger");
			if(labelTarget != null){
				if(lev == 8){
					labelTarget.GetStorableByID("Text").SetStringParamValue("text", "Play Random" );
				} else {
					labelTarget.GetStorableByID("Text").SetStringParamValue("text", "Play Level" + lev.ToString() );
				}
			}
		}

		void LevelChanger(){
			Atom targetAtom = SuperController.singleton.GetAtomByUid("LevelChanger");

			if(Sd.levelInfo == 8){
				targetAtom.SetOn(true);
			} else {
				targetAtom.SetOn(false);
			}
		}


		// PlayButton(forLevel)
		void startSexCallback(){
				
				if(SexAnimation==true) return;

				//VRDildo_statusCheack
				var tgtAtomName = manName;
				Atom manAtom = SuperController.singleton.GetAtomByUid(tgtAtomName);
				JSONStorable VRDILDO = manAtom.GetStorableByID("plugin#0_NeMech.VRDildo");
				if(VRDILDO != null){
					if(VRDILDO.GetBoolParamValue("activeStatus") == false ) {
						return ;
					}
				}
			
				SexAnimation = true;
			
			
				CollisionTrigger executeTrigger = containingAtom.GetStorableByID("CollisionTrigger") as CollisionTrigger;
				JSONClass trigClass = executeTrigger.trigger.GetJSON();
				JSONArray trigArray = trigClass["startActions"].AsArray;
// 0: insertStatus Move
// 1: SexBody
// 2: Sex Emotion
// 3: Orgasm : Call From MAMMoan
// 4: Sex

			trigArray[1]["enabled"].Value = "true";		// 2: PersonTL text
			trigArray[2]["enabled"].Value = "true";		// 2: PersonTL text
			trigArray[3]["enabled"].Value = "true";		// 3: Orgasm : Call From MAMMoan


			string animeName1;
			string animeName2;
			string animeName3;


			animeName1 = "None";
			animeName2 = "Play L1insert/*";
			animeName3 = "Play L1Orgasm";

			

			trigArray[1]["receiverTargetName"].Value = animeName1; //exp TL
			trigArray[2]["receiverTargetName"].Value = animeName2; //mov TL
			trigArray[3]["receiverTargetName"].Value = animeName3; //Org TL


				executeTrigger.trigger.RestoreFromJSON(trigClass);

			
//Mask trigger
				var maskMomanSTr = trigArray[3]["receiverTargetName"].Value;
				trigArray[3]["receiverTargetName"].Value = "None";
				executeTrigger.trigger.RestoreFromJSON(trigClass);


				executeTrigger.trigger.active = true;
				executeTrigger.trigger.active = false;		

//Recover trigger
//				trigArray[0]["receiverTargetName"].Value = "None";
				trigArray[1]["receiverTargetName"].Value = "enabled";
				trigArray[2]["receiverTargetName"].Value = "enabled";
				trigArray[3]["receiverTargetName"].Value = maskMomanSTr;

			
				executeTrigger.trigger.RestoreFromJSON(trigClass);

				
			
		}

		void insertStatusCallback(){

			if(SexAnimation==false) return;

			CollisionTrigger executeTrigger = containingAtom.GetStorableByID("CollisionTrigger") as CollisionTrigger;
			JSONClass trigClass = executeTrigger.trigger.GetJSON();
			JSONArray trigArray = trigClass["startActions"].AsArray;

			string womanAtomName = trigArray[3]["receiverAtom"].Value;
			CollisionTrigger VTrigger;

			Atom womanAtom = SuperController.singleton.GetAtomByUid(womanAtomName);
			VTrigger = womanAtom.GetStorableByID("VaginaTrigger") as CollisionTrigger;



			//VAMMValue_TriggerCount Cheack;
			bool MoanCK = false;
			var tgtPluginName = pluginDetect( womanAtom , "_VAMMoanPlugin.VAMMoan" );
			if(tgtPluginName == ""){
				pluginInfo.val = womanAtomName +"'s Plugin 'VAMMoanPlugin.VAMMoan'is not find.";
			} else {



				JSONStorable VAMMOAN = womanAtom.GetStorableByID(tgtPluginName);
				if( VAMMValue_TriggerCount > VAMMOAN.GetFloatParamValue("VAMM TriggerCount") ){
					VTrigger.trigger.active = false;
					MoanCK = true;

				}
				VAMMValue_TriggerCount = VAMMOAN.GetFloatParamValue("VAMM TriggerCount");

			}

			//VRDildo_statusCheack
			var tgtAtomName = manName;
			Atom manAtom = SuperController.singleton.GetAtomByUid(tgtAtomName);
			JSONStorable VRDILDO = manAtom.GetStorableByID("plugin#0_NeMech.VRDildo");
			if(VRDILDO != null){
				if(VRDILDO.GetBoolParamValue("activeStatus") == false ) MoanCK = true;
			}

			
			

			if(VTrigger.trigger.active == false | MoanCK == true ) {  // Not insert


				SexAnimation = false;

				string animeName1;

				animeName1 = "Play noAct/*";


				trigArray[2]["receiverTargetName"].Value = animeName1;

				executeTrigger.trigger.RestoreFromJSON(trigClass);

//Mask trigger
				var maskMomanSTr = trigArray[3]["receiverTargetName"].Value;
				trigArray[3]["receiverTargetName"].Value = "";
				executeTrigger.trigger.RestoreFromJSON(trigClass);


				executeTrigger.trigger.active = true;
				executeTrigger.trigger.active = false;		

//Recover trigger
				trigArray[3]["receiverTargetName"].Value = maskMomanSTr;
				trigArray[2]["receiverTargetName"].Value = "enabled";
				executeTrigger.trigger.RestoreFromJSON(trigClass);
			}

		}

// NemechL
		private string pluginDetect( Atom tgtAtm , string pluginName ) {
			string rval;
			rval = "";

			tgtAtm.GetStorableIDs().ForEach((name)=>
			{
				if(name.EndsWith(pluginName)){
					rval = name;
				}
			}); 
			return rval;
		}



		// Save
		void gameSave(){

			
			Sd.thisPlaytime ++;;	// time count

			if( ! FileManagerSecure.DirectoryExists(SavePath, true) ){
				FileManagerSecure.CreateDirectory(SavePath );
			}
			if(Sd.FirstBoot == "") Sd.FirstBoot = DateTime.Now.ToString();
			if(Sd.lastBoot == "") Sd.lastBoot = DateTime.Now.ToString();

			FileManagerSecure.WriteAllText(SavePath + SaveFile,JsonUtility.ToJson(Sd, true));

		
		} 

		// Load
		void gameLoad(){
			
			if( FileManagerSecure.FileExists(SavePath + SaveFile, true )){
				string val =  FileManagerSecure.ReadAllText(SavePath + SaveFile);
				Sd = JsonUtility.FromJson<SaveData>( val );

			
			} else {
				Sd.id = "test";
				Sd.startCount = 0;
				Sd.totalPlaytime =0;
				Sd.favRate = 0;
			
			}
			if(Sd.ShortestOrgasmTimeInterval == "" ) Sd.ShortestOrgasmTimeInterval = new TimeSpan(11, 59, 59).ToString();
		
		
		}
		
	    public class SaveData
    	{
       		public string id;
        	public int  startCount;
        	public int  favRate;

    	    public string FirstBoot;
    	    public string lastBoot;

    	    public int thisPlaytime;		// gameCount per 2min
			public int totalPlaytime;

			public int totalOrgasmCount;
			public int maximumOrgasmCount;
			public int thisOrgasmCount;
			public int EffeciveOrgasmCount;

			public int levelInfo;
			public string ShortestOrgasmTimeInterval;
    		
			public bool debugMode;

			public SaveData Clone() {
				return (SaveData) MemberwiseClone();
			}
	    }
	}
}
